(ns clojsa.saclient
  (:require [clj-http.client :as client]))

(def url "https://forums.somethingawful.com/")

(defn cookie-store [cookies]
  (let [cs (clj-http.cookies/cookie-store)
        v (vec cookies)]
    (for [c v]
      (println c))
    cs))

(defn thread-url
  ([id]
   (thread-url id 1))
  ([id page]
   (let [base-url (str url "showthread.php")
         query {:threadid id
                :pagenumber page}]
     {:href base-url :params query})))

(defn do-login []
  (let [login-url (str url "account.php")
        cs (clj-http.cookies/cookie-store)]
    (client/post login-url {:form-params {:action "login"
                                          :username "xf86enodev"
                                          :password "triebhaftigke1t"}
                            :cookie-store cs})
    (clj-http.cookies/get-cookies cs)))

(defn thread-response [session url]
  (let [cs (cookie-store (:cookies session))
        resp (client/get (:href url) {:query-params (:params url)
                                      :cookie-store cs
                                      :debug false})]
    (:body resp)))

;; (def witcher-thread (thread-response (thread-url 3720352 3)))
